SystemOrganization addCategory: #'Pier-Links-Media'!
SystemOrganization addCategory: #'Pier-Links-Tests'!
SystemOrganization addCategory: #'Pier-Links-Text'!

PRExternalLink subclass: #PRExternalReferenceLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Links-Text'!

PRExternalReferenceLink subclass: #PRDoiLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Links-Text'!

!PRDoiLink class methodsFor: 'testing' stamp: 'dc 10/9/2008 15:49'!
isValidReference: aString
	^ aString beginsWith: 'doi:'! !

!PRDoiLink methodsFor: 'visiting' stamp: 'dc 10/9/2008 15:49'!
accept: aVisitor
	aVisitor visitDoiLink: self! !

!PRDoiLink methodsFor: 'accessing' stamp: 'lr 11/13/2008 13:55'!
title
	^ 'DOI ' , self urlEntry! !

!PRDoiLink methodsFor: 'accessing' stamp: 'dc 10/9/2008 15:51'!
urlPrefix
	^ 'http://dx.doi.org/'! !

!PRExternalReferenceLink class methodsFor: 'testing' stamp: 'damiencassou 7/23/2009 16:04'!
isAbstract 
	^ true! !

!PRExternalReferenceLink methodsFor: 'visitor accepting' stamp: 'damiencassou 7/23/2009 14:55'!
accept: aVisitor
	aVisitor visitExternalReferenceLink: self! !

!PRExternalReferenceLink methodsFor: 'accessing-dynamic' stamp: 'damiencassou 7/23/2009 14:53'!
urlEntry
	^ super urlEntry copyAfter: $:! !

!PRExternalReferenceLink methodsFor: 'accessing-dynamic' stamp: 'damiencassou 7/23/2009 15:02'!
urlParameters
	"Prints parameters that have been passed to the external link. Example:
	+youtube:uLJ_QVfT_wM|fs=1|color1=0x2b405b|color2=0x6b8ab6|border=1+"
	^ String streamContents: [:stream |
		
		self parameters do: [:assoc | 
			stream
				nextPut: $&;
				nextPutAll: assoc key;
				nextPut: $=;
				nextPutAll: assoc value]
		]! !

PRExternalReferenceLink subclass: #PRGoogleLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Links-Text'!

!PRGoogleLink class methodsFor: 'testing' stamp: 'lr 8/26/2007 17:35'!
isValidReference: aString
	^ aString beginsWith: 'google:'! !

!PRGoogleLink methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitGoogleLink: self! !

!PRGoogleLink methodsFor: 'accessing' stamp: 'lr 2/7/2007 15:15'!
title
	^ 'Google (' , self urlEntry , ')'! !

!PRGoogleLink methodsFor: 'accessing' stamp: 'lr 9/4/2006 11:30'!
urlPrefix
	^ 'http://www.google.com/search?q='! !

PRExternalReferenceLink subclass: #PRIsbnLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Links-Text'!

!PRIsbnLink commentStamp: 'lr 5/28/2006 20:46' prior: 0!
I am an external link pointing to an ISBN (International Standard Book Number).!

!PRIsbnLink class methodsFor: 'testing' stamp: 'lr 8/26/2007 17:35'!
isValidReference: aString
	^ aString beginsWith: 'isbn:'! !

!PRIsbnLink methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitIsbnLink: self! !

!PRIsbnLink methodsFor: 'accessing' stamp: 'lr 10/20/2006 11:42'!
title
	^ 'ISBN ' , self urlEntry! !

!PRIsbnLink methodsFor: 'accessing' stamp: 'lr 9/8/2008 17:41'!
urlImage
	^ 'http://ecx.images-amazon.com/images/P/' , self urlEntry! !

!PRIsbnLink methodsFor: 'accessing' stamp: 'lr 9/8/2008 17:42'!
urlPrefix
	^ 'http://www.amazon.com/dp/'! !

PRExternalReferenceLink subclass: #PRRfcLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Links-Text'!

!PRRfcLink commentStamp: 'lr 5/28/2006 20:46' prior: 0!
I am an external link pointing to a RFC (Request for Comments) document.!

!PRRfcLink class methodsFor: 'testing' stamp: 'lr 8/26/2007 17:35'!
isValidReference: aString
	^ aString beginsWith: 'rfc:'! !

!PRRfcLink methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitRfcLink: self! !

!PRRfcLink methodsFor: 'accessing' stamp: 'lr 10/20/2006 12:06'!
title
	^ 'RFC ' , self urlEntry! !

!PRRfcLink methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
urlPostfix
	^ '.html'! !

!PRRfcLink methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
urlPrefix
	^ 'http://www.faqs.org/rfcs/rfc'! !

PRExternalReferenceLink subclass: #PRSlideShareLink
	instanceVariableNames: 'data'
	classVariableNames: 'ApiKey SharedSecret'
	poolDictionaries: ''
	category: 'Pier-Links-Media'!

!PRSlideShareLink class methodsFor: 'testing' stamp: 'lr 4/23/2009 20:34'!
isValidReference: aString
	^ ApiKey notNil and: [ SharedSecret notNil and: [ aString beginsWith: 'slideshare:' ] ]! !

!PRSlideShareLink class methodsFor: 'initialization' stamp: 'lr 4/23/2009 20:33'!
reset
	"Get from <http://www.slideshare.net/developers/applyforapi>."

	ApiKey := MACompatibility
		request: 'SlideShare API Key:'
		default: ''.
	SharedSecret := MACompatibility
		request: 'SlideShare Shared Secret:'
		default: ''! !

!PRSlideShareLink methodsFor: 'visiting' stamp: 'lr 9/8/2008 21:31'!
accept: aVisitor
	aVisitor visitSlideSlideLink: self! !

!PRSlideShareLink methodsFor: 'private' stamp: 'lr 11/13/2008 14:41'!
fetch: aString
	| ts hash url response result |
	ts := Time totalSeconds asString.
	hash := ((SecureHashAlgorithm new
		hashMessage: SharedSecret , ts)
		printStringBase: 16)
		asLowercase.
	url := 'http://www.slideshare.net/api/1/get_slideshow_info?api_key=' , 
		ApiKey , '&ts=' , ts , '&hash=' , hash , '&slideshow_id=' , aString.
	response := PRHttpGet url: url.
	result := Dictionary new.
	response isString ifFalse: [
		(XMLDOMParser parseDocumentFrom: response)
			tagsNamed: #Slideshow do: [ :element |
				element elementsDo: [ :each |
					result at: each localName put: each contentString ] ] ].
	^ result! !

!PRSlideShareLink methodsFor: 'accessing-parameters' stamp: 'lr 9/8/2008 21:56'!
height
	^ self parameterAt: 'height' ifAbsent: [ (self width / 1.1972) rounded ]! !

!PRSlideShareLink methodsFor: 'accessing-dynamic' stamp: 'lr 9/8/2008 21:38'!
id
	^ data at: #PlayerDoc ifAbsent: [ String new ]! !

!PRSlideShareLink methodsFor: 'testing' stamp: 'lr 9/8/2008 21:28'!
isBroken
	^ data isEmpty! !

!PRSlideShareLink methodsFor: 'accessing' stamp: 'lr 9/8/2008 21:45'!
reference: aString
	super reference: aString.
	data := self fetch: self urlEntry! !

!PRSlideShareLink methodsFor: 'accessing-dynamic' stamp: 'lr 9/8/2008 21:26'!
title
	^ data at: #Title ifAbsent: [ super title ]! !

!PRSlideShareLink methodsFor: 'accessing-dynamic' stamp: 'lr 9/8/2008 21:29'!
url
	^ data at: #URL ifAbsent: [ super url ]! !

!PRSlideShareLink methodsFor: 'accessing-dynamic' stamp: 'lr 9/8/2008 21:30'!
urlPrefix
	^ '#'! !

!PRSlideShareLink methodsFor: 'accessing-parameters' stamp: 'lr 9/8/2008 17:06'!
width
	^ self parameterAt: 'width' ifAbsent: [ 425 ]! !

PRExternalReferenceLink subclass: #PRVimeoLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Links-Media'!

!PRVimeoLink class methodsFor: 'testing' stamp: 'lr 9/29/2008 07:45'!
isValidReference: aString
	^ aString beginsWith: 'vimeo:'! !

!PRVimeoLink methodsFor: 'visiting' stamp: 'lr 9/29/2008 07:51'!
accept: aVisitor
	aVisitor visitVimeoLink: self! !

!PRVimeoLink methodsFor: 'accessing-parameters' stamp: 'lr 9/29/2008 07:47'!
height
	^ self parameterAt: 'height' ifAbsent: [ 225 ]! !

!PRVimeoLink methodsFor: 'accessing' stamp: 'lr 9/29/2008 07:46'!
urlPrefix
	^ 'http://vimeo.com/'! !

!PRVimeoLink methodsFor: 'accessing-parameters' stamp: 'lr 9/29/2008 07:46'!
width
	^ self parameterAt: 'width' ifAbsent: [ 400 ]! !

PRExternalReferenceLink subclass: #PRWikipediaLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Links-Text'!

!PRWikipediaLink class methodsFor: 'testing' stamp: 'damiencassou 11/13/2008 16:25'!
isValidReference: aString
	^ aString beginsWith: 'wikipedia:'! !

!PRWikipediaLink methodsFor: 'as yet unclassified' stamp: 'damiencassou 11/13/2008 16:26'!
accept: aVisitor
	aVisitor visitWikipediaLink: self! !

!PRWikipediaLink methodsFor: 'as yet unclassified' stamp: 'damiencassou 11/13/2008 16:26'!
title
	^ 'Wikipedia (' , self urlEntry, ')'! !

!PRWikipediaLink methodsFor: 'as yet unclassified' stamp: 'damiencassou 11/13/2008 16:27'!
urlPrefix
	^ 'http://en.wikipedia.org/wiki/'! !

PRExternalReferenceLink subclass: #PRYouTubeLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Links-Media'!

!PRYouTubeLink class methodsFor: 'testing' stamp: 'lr 9/29/2008 07:31'!
isValidReference: aString
	^ aString beginsWith: 'youtube:'! !

!PRYouTubeLink methodsFor: 'visiting' stamp: 'lr 9/29/2008 07:31'!
accept: aVisitor
	aVisitor visitYouTubeLink: self! !

!PRYouTubeLink methodsFor: 'accessing-parameters' stamp: 'lr 9/29/2008 07:32'!
height
	^ self parameterAt: 'height' ifAbsent: [ 344 ]! !

!PRYouTubeLink methodsFor: 'accessing' stamp: 'lr 9/29/2008 07:36'!
urlPrefix
	^ 'http://www.youtube.com/watch?v='! !

!PRYouTubeLink methodsFor: 'accessing-parameters' stamp: 'lr 9/29/2008 07:32'!
width
	^ self parameterAt: 'width' ifAbsent: [ 425 ]! !

PRExternalLinkTest subclass: #PRDoiLinkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Links-Tests'!

!PRDoiLinkTest methodsFor: 'private' stamp: 'dc 10/9/2008 15:45'!
actualClass
	^ PRDoiLink ! !

!PRDoiLinkTest methodsFor: 'private' stamp: 'dc 10/9/2008 15:46'!
referenceString
	^ 'doi:10.1016/j.cl.2008.05.004'! !

!PRDoiLinkTest methodsFor: 'testing-accessing' stamp: 'lr 11/13/2008 13:59'!
testTitle
	self instance reference: self referenceString.
	self assert: self instance title = 'DOI 10.1016/j.cl.2008.05.004'! !

!PRDoiLinkTest methodsFor: 'testing-accessing' stamp: 'lr 11/13/2008 14:06'!
testUrl
	self instance reference: self referenceString.
	self assert: self instance url = 'http://dx.doi.org/10.1016/j.cl.2008.05.004'! !

PRExternalLinkTest subclass: #PRGoogleLinkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Links-Tests'!

!PRGoogleLinkTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRGoogleLinkTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRGoogleLink! !

!PRGoogleLinkTest methodsFor: 'private' stamp: 'lr 11/13/2008 14:03'!
referenceString
	^ 'google:pier'! !

!PRGoogleLinkTest methodsFor: 'testing-accessing' stamp: 'lr 11/13/2008 14:03'!
testTitle
	self instance reference: self referenceString.
	self assert: self instance title = 'Google (pier)'! !

!PRGoogleLinkTest methodsFor: 'testing-accessing' stamp: 'lr 11/13/2008 14:06'!
testUrl
	self instance reference: self referenceString.
	self assert: self instance url = 'http://www.google.com/search?q=pier'! !

PRExternalLinkTest subclass: #PRIsbnLinkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Links-Tests'!

!PRIsbnLinkTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRIsbnLinkTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRIsbnLink! !

!PRIsbnLinkTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
referenceString
	^ 'isbn:1590594916'! !

!PRIsbnLinkTest methodsFor: 'testing-accessing' stamp: 'lr 11/13/2008 14:03'!
testTitle
	self instance reference: self referenceString.
	self assert: self instance title = 'ISBN 1590594916'! !

!PRIsbnLinkTest methodsFor: 'testing-accessing' stamp: 'lr 11/13/2008 14:06'!
testUrl
	self instance reference: self referenceString.
	self assert: self instance url = 'http://www.amazon.com/dp/1590594916'! !

PRExternalLinkTest subclass: #PRRfcLinkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Links-Tests'!

!PRRfcLinkTest class methodsFor: 'testing' stamp: 'lr 3/30/2007 22:22'!
isAbstract
	^ false! !

!PRRfcLinkTest methodsFor: 'private' stamp: 'lr 3/30/2007 22:22'!
actualClass
	^ PRRfcLink! !

!PRRfcLinkTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
referenceString
	^ 'rfc:1896'! !

!PRRfcLinkTest methodsFor: 'testing-accessing' stamp: 'lr 11/13/2008 14:03'!
testTitle
	self instance reference: self referenceString.
	self assert: self instance title = 'RFC 1896'! !

!PRRfcLinkTest methodsFor: 'testing-accessing' stamp: 'lr 11/13/2008 14:06'!
testUrl
	self instance reference: self referenceString.
	self assert: self instance url = 'http://www.faqs.org/rfcs/rfc1896.html'! !

PRExternalLinkTest subclass: #PRSlideShareLinkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Links-Tests'!

!PRSlideShareLinkTest class methodsFor: 'testing' stamp: 'lr 11/13/2008 14:00'!
isAbstract
	^ false! !

!PRSlideShareLinkTest methodsFor: 'private' stamp: 'lr 11/13/2008 14:01'!
actualClass
	^ PRSlideShareLink! !

!PRSlideShareLinkTest methodsFor: 'running' stamp: 'lr 11/13/2008 14:42'!
performTest
	[ super performTest ] on: PRHttpGet do: [ :err | err resume: self response readStream ]! !

!PRSlideShareLinkTest methodsFor: 'private' stamp: 'lr 11/13/2008 14:02'!
referenceString
	^ 'slideshare:243906'! !

!PRSlideShareLinkTest methodsFor: 'private' stamp: 'lr 11/13/2008 14:42'!
response
	^ '<?xml version="1.0" encoding="UTF-8"?><Slideshow>  <ID>243906</ID>  <Title>Transactional Memory for Smalltalk</Title>  <Description>Concurrency control is mostly based on locks and is therefore notoriously difficult to use. Even though some programming languages provide high-level constructs, these add complexity and potentially hard-to-detect bugs to the application. Transactional memory is an attractive mechanism that does not have the drawbacks of locks, however the underlying implementation is often difficult to integrate into an existing language. In this paper we show how we have introduced transactional semantics into Smalltalk by using the reflective facilities of the language. Our approach is based on method annotations, incremental parse tree transformations and an optimistic commit protocol. The implementation does not depend on modifications to the virtual machine and therefor can be changed at the language level. We report on a practical case study, benchmarks and further and on-going work.</Description>  <Status>2</Status>  <EmbedCode>&lt;div style=&quot;width:425px;text-align:left&quot; id=&quot;__ss_243906&quot;&gt;&lt;object style=&quot;margin:0px&quot; width=&quot;425&quot; height=&quot;355&quot;&gt;&lt;param name=&quot;movie&quot; value=&quot;http://static.slideshare.net/swf/ssplayer2.swf?doc=transactional-memory-for-smalltalk-120152790782588-4&quot;/&gt;&lt;param name=&quot;allowFullScreen&quot; value=&quot;true&quot;/&gt;&lt;param name=&quot;allowScriptAccess&quot; value=&quot;always&quot;/&gt;&lt;embed src=&quot;http://static.slideshare.net/swf/ssplayer2.swf?doc=transactional-memory-for-smalltalk-120152790782588-4&quot; type=&quot;application/x-shockwave-flash&quot; allowscriptaccess=&quot;always&quot; allowfullscreen=&quot;true&quot; width=&quot;425&quot; height=&quot;355&quot;&gt;&lt;/embed&gt;&lt;/object&gt;&lt;div style=&quot;font-size:11px;font-family:tahoma,arial;height:26px;padding-top:2px;&quot;&gt;&lt;a href=&quot;http://www.slideshare.net/?src=apiembed&quot;&gt;&lt;img src=&quot;http://static.slideshare.net/swf/logo_embd.png&quot; style=&quot;border:0px none;margin-bottom:-5px&quot; alt=&quot;SlideShare&quot;/&gt;&lt;/a&gt; | &lt;a href=&quot;http://www.slideshare.net/renggli/transactional-memory-for-smalltalk?src=apiembed&quot; title=&quot;View Transactional Memory for Smalltalk on SlideShare&quot;&gt;View&lt;/a&gt; | &lt;a href=&quot;http://www.slideshare.net/upload?src=apiembed&quot;&gt;Upload your own&lt;/a&gt;&lt;/div&gt;&lt;/div&gt;</EmbedCode>  <PlayerDoc>transactional-memory-for-smalltalk-120152790782588-4</PlayerDoc>  <TotalSlides>26</TotalSlides>  <URLDoc>transactional-memory-for-smalltalk</URLDoc>  <Language>en</Language>  <URL>http://www.slideshare.net/renggli/transactional-memory-for-smalltalk</URL>  <UserID>261032</UserID>  <UserLogin>renggli</UserLogin>  <RelatedSlideshows>202978,135777,238145,238145,244839,244839,73521,85720,</RelatedSlideshows>  <ThumbnailURL>http://cdn.slideshare.net/transactional-memory-for-smalltalk-120152790782588-4-thumbnail?1201527907</ThumbnailURL>  <ThumbnailSmallURL>http://cdn.slideshare.net/transactional-memory-for-smalltalk-120152790782588-4-thumbnail-2</ThumbnailSmallURL>  <Tags>concurrent-programming transactional-memory smalltalk esug language-constructs-and-features</Tags>  <Created>Mon Jan 28 13:45:07 UTC 2008</Created></Slideshow>'! !

!PRSlideShareLinkTest methodsFor: 'testing-accessing' stamp: 'lr 11/13/2008 14:05'!
testTitle
	self instance reference: self referenceString.
	self assert: self instance title = 'Transactional Memory for Smalltalk'! !

!PRSlideShareLinkTest methodsFor: 'testing-accessing' stamp: 'lr 11/13/2008 14:05'!
testUrl
	self instance reference: self referenceString.
	self assert: self instance url =  'http://www.slideshare.net/renggli/transactional-memory-for-smalltalk'! !

PRExternalLinkTest subclass: #PRVimeoLinkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Links-Tests'!

!PRVimeoLinkTest class methodsFor: 'testing' stamp: 'lr 11/13/2008 14:00'!
isAbstract
	^ false! !

!PRVimeoLinkTest methodsFor: 'private' stamp: 'lr 11/13/2008 14:00'!
actualClass
	^ PRVimeoLink! !

!PRVimeoLinkTest methodsFor: 'private' stamp: 'lr 11/13/2008 14:14'!
referenceString
	^ 'vimeo:2007269'! !

!PRVimeoLinkTest methodsFor: 'testing-accessing' stamp: 'lr 11/13/2008 14:13'!
testTitle
	self instance reference: self referenceString.
	self assert: self instance title = 'vimeo:2007269'! !

!PRVimeoLinkTest methodsFor: 'testing-accessing' stamp: 'lr 11/13/2008 14:13'!
testUrl
	self instance reference: self referenceString.
	self assert: self instance url = 'http://vimeo.com/2007269'! !

PRExternalLinkTest subclass: #PRWikipediaLinkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Links-Tests'!

!PRWikipediaLinkTest class methodsFor: 'testing' stamp: 'damiencassou 11/13/2008 16:21'!
isAbstract
	^ false! !

!PRWikipediaLinkTest methodsFor: 'as yet unclassified' stamp: 'damiencassou 11/13/2008 16:22'!
actualClass
	^ PRWikipediaLink ! !

!PRWikipediaLinkTest methodsFor: 'as yet unclassified' stamp: 'damiencassou 11/13/2008 16:30'!
referenceString
	^ 'wikipedia:Rene Magritte'! !

!PRWikipediaLinkTest methodsFor: 'as yet unclassified' stamp: 'damiencassou 11/13/2008 16:28'!
testTitle
	self instance reference: self referenceString.
	self assert: self instance title = 'Wikipedia (Rene Magritte)'! !

!PRWikipediaLinkTest methodsFor: 'as yet unclassified' stamp: 'damiencassou 11/13/2008 16:25'!
testUrl
	self instance reference: self referenceString.
	self assert: self instance url = 'http://en.wikipedia.org/wiki/Rene Magritte'! !

PRExternalLinkTest subclass: #PRYouTubeLinkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Links-Tests'!

!PRYouTubeLinkTest class methodsFor: 'testing' stamp: 'lr 11/13/2008 14:00'!
isAbstract
	^ false! !

!PRYouTubeLinkTest methodsFor: 'private' stamp: 'lr 11/13/2008 14:00'!
actualClass
	^ PRYouTubeLink! !

!PRYouTubeLinkTest methodsFor: 'private' stamp: 'lr 11/13/2008 14:11'!
referenceString
	^ 'youtube:TtoGwy3RPGI'! !

!PRYouTubeLinkTest methodsFor: 'testing-accessing' stamp: 'damiencassou 7/23/2009 15:04'!
testFullscreen
	self instance reference: self referenceString.
	self instance parameterAt: 'fs' put: '1'.
	self assert: self instance url, self instance urlParameters = 'http://www.youtube.com/watch?v=TtoGwy3RPGI&fs=1'! !

!PRYouTubeLinkTest methodsFor: 'testing-accessing' stamp: 'lr 11/13/2008 14:13'!
testTitle
	self instance reference: self referenceString.
	self assert: self instance title = 'youtube:TtoGwy3RPGI'! !

!PRYouTubeLinkTest methodsFor: 'testing-accessing' stamp: 'lr 11/13/2008 14:11'!
testUrl
	self instance reference: self referenceString.
	self assert: self instance url = 'http://www.youtube.com/watch?v=TtoGwy3RPGI'! !

Notification subclass: #PRHttpGet
	instanceVariableNames: 'url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Links-Media'!

!PRHttpGet class methodsFor: 'instance-creation' stamp: 'lr 11/13/2008 14:23'!
url: aString
	^ self new
		url: aString;
		signal! !

!PRHttpGet methodsFor: 'defaults' stamp: 'lr 11/13/2008 14:22'!
defaultAction
	^ HTTPSocket httpGet: self url! !

!PRHttpGet methodsFor: 'accessing' stamp: 'lr 11/13/2008 14:22'!
url
	^ url! !

!PRHttpGet methodsFor: 'accessing' stamp: 'lr 11/13/2008 14:22'!
url: aString
	url := aString! !

!PRVisitor methodsFor: '*pier-links-text' stamp: 'damiencassou 7/23/2009 14:56'!
visitDoiLink: anObject
	self visitExternalReferenceLink: anObject! !

!PRVisitor methodsFor: '*pier-links-text' stamp: 'damiencassou 7/23/2009 14:56'!
visitExternalReferenceLink: aLink
	self visitExternalLink: aLink ! !

!PRVisitor methodsFor: '*pier-links-text' stamp: 'damiencassou 7/23/2009 14:56'!
visitGoogleLink: anObject
	self visitExternalReferenceLink: anObject! !

!PRVisitor methodsFor: '*pier-links-text' stamp: 'damiencassou 7/23/2009 14:56'!
visitIsbnLink: anObject
	self visitExternalReferenceLink: anObject! !

!PRVisitor methodsFor: '*pier-links-text' stamp: 'damiencassou 7/23/2009 14:56'!
visitRfcLink: anObject
	self visitExternalReferenceLink: anObject! !

!PRVisitor methodsFor: '*pier-links-media' stamp: 'damiencassou 7/23/2009 14:56'!
visitSlideSlideLink: anObject
	self visitExternalReferenceLink: anObject! !

!PRVisitor methodsFor: '*pier-links-media' stamp: 'damiencassou 7/23/2009 14:57'!
visitVimeoLink: anObject 
	self visitExternalReferenceLink: anObject! !

!PRVisitor methodsFor: '*pier-links-text' stamp: 'damiencassou 7/23/2009 14:56'!
visitWikipediaLink: anObject
	self visitExternalReferenceLink: anObject! !

!PRVisitor methodsFor: '*pier-links-media' stamp: 'damiencassou 7/23/2009 14:57'!
visitYouTubeLink: anObject 
	self visitExternalReferenceLink: anObject! !

!PREmbeddedRenderer methodsFor: '*pier-links-text' stamp: 'lr 3/25/2009 00:08'!
visitIsbnLink: aLink
	(self anchorFor: aLink)
		url: aLink url;
		with: [ html image url: aLink urlImage ]! !

!PREmbeddedRenderer methodsFor: '*pier-links-media' stamp: 'lr 3/25/2009 00:06'!
visitSlideSlideLink: aLink
	html html: '<object style="margin: 0px" width="' , aLink width asString , '" height="' , aLink height asString , '"><param name="movie" value="http://static.slideshare.net/swf/ssplayer2.swf?doc=' , aLink id , '&rel=0"/><param name="allowFullScreen" value="true"/><param name="allowScriptAccess" value="always"/><embed src="http://static.slideshare.net/swf/ssplayer2.swf?doc=' , aLink id , '&rel=0" type="application/x-shockwave-flash" allowscriptaccess="always" allowfullscreen="true" width="' , aLink width asString , '" height="' , aLink height asString , '"></embed></object>'! !

!PREmbeddedRenderer methodsFor: '*pier-links-media' stamp: 'lr 3/25/2009 00:06'!
visitVimeoLink: aLink 
	html html: '<object width="' , aLink width asString , '" height="' , aLink height asString , '"><param name="allowfullscreen" value="true" /><param name="allowscriptaccess" value="always" /><param name="movie" value="http://vimeo.com/moogaloop.swf?clip_id=' , aLink urlEntry , '&amp;server=vimeo.com&amp;show_title=1&amp;show_byline=1&amp;show_portrait=0&amp;color=&amp;fullscreen=1" /><embed src="http://vimeo.com/moogaloop.swf?clip_id=' , aLink urlEntry , '&amp;server=vimeo.com&amp;show_title=1&amp;show_byline=1&amp;show_portrait=0&amp;color=&amp;fullscreen=1" type="application/x-shockwave-flash" allowfullscreen="true" allowscriptaccess="always" width="' , aLink width asString , '" height="' , aLink height asString , '"></embed></object>'! !

!PREmbeddedRenderer methodsFor: '*pier-links-media' stamp: 'damiencassou 7/23/2009 15:03'!
visitYouTubeLink: aLink 
	html html: '<object width="' , aLink width asString , '" height="' , aLink height asString , '"><param name="movie" value="http://www.youtube.com/v/' , aLink urlEntry, aLink urlParameters, '"></param><param name="allowFullScreen" value="true"></param><embed src="http://www.youtube.com/v/' , aLink urlEntry, aLink urlParameters, '" type="application/x-shockwave-flash" allowfullscreen="true" width="' , aLink width asString , '" height="' , aLink height asString , '"></embed></object>'! !
